import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter_localizations/flutter_localizations.dart';
import 'package:tetris/gamer/gamer.dart';
import 'package:tetris/generated/i18n.dart';
import 'package:tetris/material/audios.dart';
import 'package:tetris/pages/home_page.dart';
import 'package:tetris/utils/app_util.dart';

import 'gamer/keyboard.dart';
import 'model/config.dart';

void main() {
  debugDefaultTargetPlatformOverride = TargetPlatform.fuchsia;
  AppUtil.disableDebugPrint();
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: '俄罗斯方块',
      localizationsDelegates: [
        S.delegate,
        GlobalMaterialLocalizations.delegate,
        GlobalWidgetsLocalizations.delegate
      ],
      navigatorObservers: [routeObserver],
      supportedLocales: S.delegate.supportedLocales,
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      home: Scaffold(
        body: Sound(child: Game(child: KeyboardController(child: HomePage()))),
      ),
    );
  }
}
